-- slow start pro vrtulníky chudých majitelů nemající na ESC s pomalým rozběhem
-- 
-- budu počíta s tím, že script jede jednou za 1/20s, spočítám si inkrement za jeden tik a budu postupně přičítat
-- resp srovnám s hodnotou thr kanálu
-- 
-- některé ESC "startují" na X procentech místo na 0, tzn. chvíli se nic neděje a pak nastartují X procenty (třeba 20%), což sice
--  ozubení nepoškodí, ale dost to vrtulníkem škubne
-- pro tento případ se bude do X procent řídit střídou 


-- inputs

local inp =
    {
        { "Thr chnl", SOURCE },
        { "Thr Hold", SOURCE }, -- TH prepinac
        { "Hold val", VALUE, -1, 1, -1}, -- hold value je + nebo - Hold Val umozni otoceni smyslu.
        { "Slow (s)", VALUE, 0, 100, 10 },
        { "Treshold%", VALUE, 0, 30, 20 }
    }

-- outputs

local out = { "Slowed thr" }

local rampUp = 0 -- rampUp bude od nuly do 2048
local retval = 0
local increment = 0
local treSum = 0 -- po kolika krocich se prida dalsi step
local trePulses = 1 -- pocet kladnych pulsu v dane stride - jeden do poloviny tresholdu, dva do dvou tretin atd
local treActual = 1 -- pocitadlo pulsu

local treLimit = 0 -- do kdy se bude ridit stridou a od kdy pak jen hodnotou
local ratio = 1

local function init_func()
end

local function run_func(thr, th, thrswOffVal, sl, treshold)
    --if (th > 0 ) then 
    if (th * thrswOffVal < 0 ) then  
        retval = 0
        rampUp = 0
    else
        increment = 2048/(sl * 20) -- 20x za sekundu
        rampUp = rampUp + increment

        treLimit =  2048*treshold/100
        if (rampUp < treLimit) then
            -- rizeni stridou - prevod rampUp na sirku stridy
            ratio = trePulses / (trePulses + 1)
            if (rampUp > treLimit*ratio) then
                trePulses = trePulses + 1
            end

            -- pulz velikosti treActual
            if (treActual > 0) then
                retval = treLimit -- min velikost pulzu, kdy se roztoci motor
                treActual = treActual - 1
            else 
                retval = 0
            end

            -- budu scitat energie a pokud bude vetsi jak rampUp, budu pridavat "nuly"
            treSum = treSum + retval
            if (treActual == 0 and treSum < rampUp) then
                treSum = 0
                treActual = trePulses
            end
        else
            -- rizeni hodnotou
            if (rampUp > thr + 1024) then
                rampUp = thr + 1024
            end
            retval = rampUp
        end
    end

    return retval - 1024
end

return {init=init_func, run=run_func, input=inp, output=out}